<?php
//include "config.inc.php";
include "param.inc.php";

function get_addr($line) {
	$result = new addr();
	$ip = get_param($line, "addr add");
	$ip = explode("/", $ip);
	$result->ip = $ip[0];
	$result->subnet = $ip[1];
	$result->broadcast = get_param($line, "broadcast");
	$result->dev = get_param($line, "dev");
	return $result;
}

function get_route($line) {
	$result = new route();
	$result->route_addr = get_param($line, "via");
	$result->table = get_param($line, "table");
	$result->default = substr_count($line, "default");
	return $result;
}

function get_rule($line) {
	$result = new rule();
	$ip = get_param($line, "from");
	$ip = explode("/", $ip);
	$result->ip = $ip[0];
	$result->subnet = $ip[1];
	$result->table = get_param($line, "table");
	$result->mark = get_param($line, "fwmark");
	return $result;
}

function get_ipt($line) {
	$result = new ipt();
	$result->proto = get_param($line, "-p");
	$result->dev = get_param($line, "-i");
	$result->port = get_param($line, "--dport");
	$result->mark = get_param($line, "--set-mark");
	return $result;
}

class addr {
	var $ip;
	var $subnet;
	var $broadcast;
	var $dev;

	function is_empty() {
		if ($this->ip || $this->subnet || $this->broadcast || $this->dev) return false;
		else return true;
	}
}

class route {
	var $route_addr;
	var $table;
	var $default;

	function is_empty() {
		if ($this->route_addr || $this->table || $this->default) return false;
		else return true;
	}
}


class rule {
	var $ip;
	var $subnet;
	var $table;
	var $mark;

	function rule() {
		$this->ip = "";
		$this->subnet = "";
		$this->table = "";
		$this->mark = "";
	}

	function is_ip_rule() {
		if ($this->ip && $this->subnet && !$this->mark) return true;
		else return false;
	}

	function is_mark_rule() {
		if (!$this->ip && !$this->subnet && $this->mark) return true;
		else return false;
	}

	function is_empty() {
		if ($this->ip || $this->subnet || $this->table || $this->mark) return false;
		else return true;
	}
}

class ipt {
	var $proto;
	var $dev;
	var $port;
	var $mark;
	
	function is_empty() {
		if ($this->proto || $this->dev || $this->port || $this->mark) return false;
		else return true;
	}
}
class routing {
	var $addr;
	var $addr_count;

	var $route;
	var $route_count;

	var $rule;
	var $rule_count;
	
	var $ipt;
	var $ipt_count;

	function routing() {
		$this->addr_count = -1;
		$this->route_count = -1;
		$this->rule_count = -1;
		$this->ipt_count = -1;
	}

	function remove_empty() {
		for ($i = 0; $i <= $this->addr_count; $i++) {
			if ($found) {
				$this->addr[$i-1]->ip = $this->addr[$i]->ip;
				$this->addr[$i-1]->subnet = $this->addr[$i]->subnet;
				$this->addr[$i-1]->broadcast = $this->addr[$i]->broadcast;
				$this->addr[$i-1]->dev = $this->addr[$i]->dev;
			} elseif ($this->addr[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->addr_count--;
			$found = 0;
		}

		for ($i = 0; $i <= $this->route_count; $i++) {
			if ($found) {
				$this->route[$i-1]->route_addr = $this->route[$i]->route_addr;
				$this->route[$i-1]->table = $this->route[$i]->table;
				$this->route[$i-1]->default = $this->route[$i]->default;
			} elseif ($this->route[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->route_count--;
			$found = 0;
		}

		for ($i = 0; $i <= $this->rule_count; $i++) {
			if ($found) {
				$this->rule[$i-1]->table = $this->rule[$u]->table;
				if ($this->rule[$i]->is_ip_rule()) {
					$this->rule[$i-1]->ip = $this->rule[$i]->ip;
					$this->rule[$i-1]->subnet = $this->rule[$i]->subnet;
				} elseif ($this->rule[$i]->is_mark_rule()) {
					$this->rule[$i-1]->mark = $this->rule[$i]->mark;
				} else return false;
			} elseif ($this->rule[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->rule_count--;
			$found = 0;
		}
		
		for ($i = 0; $i <= $this->ipt_count; $i++) {
			if ($found) {
				$this->ipt[$i-1]->proto = $this->ipt[$i]->proto;
				$this->ipt[$i-1]->dev = $this->ipt[$i]->dev;
				$this->ipt[$i-1]->port = $this->ipt[$i]->port;
				$this->ipt[$i-1]->mark = $this->ipt[$i]->mark;
			} elseif ($this->ipt[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->ipt_count--;
			$found = 0;
		}
	}

	function read_routing($filename) {
		$lines = file($filename);
		$num = count($lines);

		for ($i = 0; $i < $num; $i++) {
			if ($lines[$i][0] == "#") continue;
			elseif (substr_count($lines[$i], "#IGNORE") == 1) continue;
			elseif (substr_count($lines[$i], "addr") == 1) $this->addr[++$this->addr_count] = get_addr($lines[$i]);
			elseif (substr_count($lines[$i], "route") == 1) $this->route[++$this->route_count] = get_route($lines[$i]);
			elseif (substr_count($lines[$i], "rule") == 1) $this->rule[++$this->rule_count] = get_rule($lines[$i]);
			elseif (substr_count($lines[$i], IPTABLES) == 1) $this->ipt[++$this->ipt_count] = get_ipt($lines[$i]);
			//else print("Konnte Zeile ".$i." nicht lesen\n");
		}
	}

	function write_routing($filename) {
		if(($this->addr_count == -1) && ($this->route_count == -1) && ($this->rule_count == -1) && ($this->ipt_count == -1)) return false;
		$handle = fopen($filename, "w");
		if (!$handle) return false;
		$string = "#!".INTERPRETER."\n#gernated by fireconfig v".VERSION."\n\n";
		if ($this->ipt_count != -1) {
			$string .= IPTABLES." -F #IGNORE\n".IPTABLES." -X #IGNORE\n";
		}
		fwrite($handle, $string);
		if ($this->addr_count != -1) {
			fwrite($handle, "\n#Devices\n");
			for ($i = 0; $i <= $this->addr_count; $i++) {
				$string = IPROUTE." addr add ".$this->addr[$i]->ip."/".$this->addr[$i]->subnet." broadcast ".$this->addr[$i]->broadcast." dev ".$this->addr[$i]->dev."\n";
				fwrite($handle, $string);
			}
		}
		if ($this->route_count != -1) {
			fwrite($handle, "\n#Routes\n");
			for ($i = 0; $i <= $this->route_count; $i++) {
				$string = IPROUTE." route add";
				if ($this->route[$i]->default) $string .= " default";
				$string .= " via ".$this->route[$i]->route_addr;
				if ($this->route[$i]->table) $string .= " table ".$this->route[$i]->table;
				$string .= "\n";
				fwrite($handle, $string);
			}
		}
		if ($this->rule_count != -1) {
			fwrite($handle, "\n#Rules\n");
			for ($i = 0; $i <= $this->rule_count; $i++) {
				$string = IPROUTE." rule add ";
				if ($this->rule[$i]->is_ip_rule()) {
					$string .= "from ".$this->rule[$i]->ip."/".$this->rule[$i]->subnet;
				} elseif ($this->rule[$i]->is_mark_rule()) {
					$string .= "fwmark ".$this->rule[$i]->mark;
				} else return false;
				$string .= " table ".$this->rule[$i]->table."\n";
				fwrite($handle, $string);
			}
		}
		if ($this->ipt_count != -1) {
			fwrite($handle, "\n#Iptables\n");
			for ($i = 0; $i <= $this->ipt_count; $i++) {
				$string = IPTABLES." -t mangle -A PREROUTING";
				if ($this->ipt[$i]->proto) $string .= " -p ".$this->ipt[$i]->proto;
				if ($this->ipt[$i]->dev) $string .= " -i ".$this->ipt[$i]->dev;
				if ($this->ipt[$i]->port) $string .= " --dport ".$this->ipt[$i]->port;
				$string .= " -j MARK --set-mark ".$this->ipt[$i]->mark."\n";
				fwrite($handle, $string);
			}
		}
		fclose($handle);
	}
}

?>
