<?php

//include "config.inc.php";
include "param.inc.php";

// ereg("[^0-9]",$prot) = true wenn mit buchstaben

class rule {

	var $table;
	var $proto;
	var $port;
	var $device;

	function is_empty() {
		if ($this->table || $this->proto || $this->port || $this->device) { return false; }
		else { return true; }
	}
}

class forward {

	var $proto;
	var $device;
	var $port;
	var $to;

	function is_empty() {
		if ($this->proto || $this->device || $this->port || $this->to) { return false; }
		else { return true; }
	}
}

class masq {
	
	var $device;
	var $net;
	var $subnet;
	
	function is_empty() {
		if($this->device || $this->net || $this->subnet) return true;
		else return false;
	}
}

class rules {

	var $masq_devs;
	var $masq_count;

	var $rules_forward;
	var $forward_count;

	var $rules_block;
	var $block_count;

	var $rules_accept;
	var $accept_count;

	var $rules_drop;
	var $drop_count;

	var $security;
	var $allow_inside;
	var $remote;

	function rules() {
		$this->masq_count = -1;
		$this->forward_count = -1;
		$this->block_count = -1;
		$this->accept_count = -1;
		$this->drop_count = -1;
		$this->security = 1;
		$this->allow_inside = 1;
		$this->remote = "";
	}

	function remove_empty() {
		for ($i = 0; $i <= $this->masq_count; $i++) {
			if ($found) {
				$this->masq_devs[$i-1]->device = $this->masq_devs[$i]->device;
				$this->masq_devs[$i-1]->net = $this->masq_devs[$i]->net;
				$this->masq_devs[$i-1]->subnet = $this->masq_devs[$i]->subnet;
			} elseif ($this->masq_devs[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->masq_count--;
			$found = 0;
		}

		for ($i = 0; $i <= $this->forward_count; $i++) {
			if ($found) {
				$this->rules_forward[$i-1]->proto = $this->rules_forward[$i]->proto;
				$this->rules_forward[$i-1]->device = $this->rules_forward[$i]->device;
				$this->rules_forward[$i-1]->port = $this->rules_forward[$i]->port;
				$this->rules_forward[$i-1]->to = $this->rules_forward[$i]->to;
			} elseif ($this->rules_forward[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->forward_count--;
			$found = 0;
		}

		for ($i = 0; $i <= $this->block_count; $i++) {
			if ($found) {
				$this->rules_block[$i-1]->table = $this->rules_block[$i]->table;
				$this->rules_block[$i-1]->proto = $this->rules_block[$i]->proto;
				$this->rules_block[$i-1]->port = $this->rules_block[$i]->port;
				$this->rules_block[$i-1]->device = $this->rules_block[$i]->device;
			} elseif ($this->rules_block[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->block_count--;
			$found = 0;
		}

		for ($i = 0; $i <= $this->accept_count; $i++) {
			if ($found) {
				$this->rules_accept[$i-1]->table = $this->rules_accept[$i]->table;
				$this->rules_accept[$i-1]->proto = $this->rules_accept[$i]->proto;
				$this->rules_accept[$i-1]->port = $this->rules_accept[$i]->port;
				$this->rules_accept[$i-1]->device = $this->rules_accept[$i]->device;
			} elseif ($this->rules_accept[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->accept_count--;
			$found = 0;
		}

		for ($i = 0; $i <= $this->drop_count; $i++) {
			if ($found) {
				$this->rules_drop[$i-1]->table = $this->rules_drop[$i]->table;
				$this->rules_drop[$i-1]->proto = $this->rules_drop[$i]->proto;
				$this->rules_drop[$i-1]->port = $this->rules_drop[$i]->port;
				$this->rules_drop[$i-1]->device = $this->rules_drop[$i]->device;
			} elseif ($this->rules_drop[$i]->is_empty()) {
				$found = 1;
			}
		}
		if ($found) {
			$this->drop_count--;
			$found = 0;
		}
	}

	function read_rules($filename) {
		$lines = file($filename);
		$num = count($lines);

		for ($i = 0; $i < $num; $i++) {
			if (substr_count($lines[$i], "#OPTS") == 1) {
				$this->security = get_param($lines[$i], "-s");
				$this->allow_inside = get_param($lines[$i], "-a");
			} elseif (substr_count($lines[$i], "#remote") == 1) {
				$this->remote = get_param($lines[$i], "#remote");
			} elseif ($lines[$i][0] == '#') {
				continue;
			} elseif (substr_count($lines[$i], "#IGNORE") == 1) {
				continue;
			} elseif (substr_count($lines[$i], "MASQUERADE") == 1) {
				$this->masq_count++;
				$this->masq_devs[$this->masq_count] = new masq();
				$this->masq_devs[$this->masq_count]->device = get_param($lines[$i], "-o");
				$net_subnet = explode("/", get_param($lines[$i], "-s"), 2);
				$this->masq_devs[$this->masq_count]->net = $net_subnet[0];
				$this->masq_devs[$this->masq_count]->subnet = $net_subnet[1];
			} elseif ((substr_count($lines[$i], "PREROUTING") == 1) && (substr_count($lines[$i], "DNAT --to") == 1)) {
				$this->forward_count++;
				$this->rules_forward[$this->forward_count] = new forward();
				$this->rules_forward[$this->forward_count]->proto = get_param($lines[$i], "-p");
				$this->rules_forward[$this->forward_count]->device = get_param($lines[$i], "-i");
				$this->rules_forward[$this->forward_count]->port = get_param($lines[$i], "--dport");
				$this->rules_forward[$this->forward_count]->to = get_param($lines[$i], "--to");
			} elseif (substr_count($lines[$i], "REJECT") == 1) {
				$this->block_count++;
				$this->rules_block[$this->block_count] = new rule();
				$this->rules_block[$this->block_count]->table = get_param($lines[$i], "-A");
				$this->rules_block[$this->block_count]->proto = get_param($lines[$i], "-p");
				$this->rules_block[$this->block_count]->port = get_param($lines[$i], "--dport");
				$this->rules_block[$this->block_count]->device = get_param($lines[$i], "-i");
			} elseif (substr_count($lines[$i], "ACCEPT") == 1) {
				$this->accept_count++;
				$this->rules_accept[$this->accept_count] = new rule();
				$this->rules_accept[$this->accept_count]->table = get_param($lines[$i], "-A");
				$this->rules_accept[$this->accept_count]->proto = get_param($lines[$i], "-p");
				$this->rules_accept[$this->accept_count]->port = get_param($lines[$i], "--dport");
				$this->rules_accept[$this->accept_count]->device = get_param($lines[$i], "-i");

			} elseif (substr_count($lines[$i], "DROP") == 1) {
				$this->drop_count++;
				$this->rules_drop[$this->drop_count] = new rule();
				$this->rules_drop[$this->drop_count]->table = get_param($lines[$i], "-A");
				$this->rules_drop[$this->drop_count]->proto = get_param($lines[$i], "-p");
				$this->rules_drop[$this->drop_count]->port = get_param($lines[$i], "--dport");
				$this->rules_drop[$this->drop_count]->device = get_param($lines[$i], "-i");
			} else {
				//print("Konnte Zeile ".$i." nicht lesen\n");
			}
		}
	}

	function write_batch($filename) {
		if (($this->block_count == -1) && ($this->accept_count == -1) && ($this->drop_count == -1) && ($this->masq_count == -1)) {
			return false;
		}
		$handle = fopen($filename, "w");
		if (!$handle) {
			return false;
		}
		$string = "#!".INTERPRETER."\n#gernated by fireconfig v".VERSION."\n\n".IPTABLES." -F #IGNORE\n".IPTABLES." -X #IGNORE\n".IPTABLES." -N ".CHAINNAME." #IGNORE\n";
		fwrite($handle, $string);
		fwrite($handle, "#OPTS ");
		if ($this->security) {
			fwrite($handle, "-s 1");
		} else {
			fwrite($handle, "-s 0");
		}
		if ($this->allow_inside) {
			fwrite($handle, " -a 1");
		} else {
			fwrite($handle, " -a 0");
		}
		if ($this->remote) {
			fwrite($handle, "\n#remote ".$this->remote."\n");
		}
		fwrite($handle, "\n");
		if ($this->masq_count != -1) {
			fwrite($handle, "\n#masquerading\n");
			for ($i = 0; $i <= $this->masq_count; $i++) {
				$string = IPTABLES." -t nat -s ".$this->masq_devs[$i]->net."/".$this->masq_devs[$i]->subnet." -A POSTROUTING -o ".$this->masq_devs[$i]->device." -j MASQUERADE\n";
				fwrite($handle, $string);
			}
		}
		if ($this->allow_inside) {
			fwrite($handle, "\n#allow everything from inside\n");
			fwrite($handle, IPTABLES." -A ".CHAINNAME." -m state --state ESTABLISHED,RELATED -j ACCEPT #IGNORE\n");
			/*for ($i = 0; $i <= $this->masq_count; $i++) {
				fwrite($handle, IPTABLES." -A ".CHAINNAME." -m state --state NEW -i ! ".$this->masq_devs[$i]." -j ACCEPT #IGNORE\n");
			}*/
			
			if ($this->remote) {
				fwrite($handle, IPTABLES." -A ".CHAINNAME." -m state --state NEW -i ! ".$this->remote." -j ACCEPT #IGNORE\n");
			}
		}
		if ($this->accept_count != -1) {
			fwrite($handle, "\n#allows\n");
			for ($i = 0; $i <= $this->accept_count; $i++) {
				$string = IPTABLES." -A ".CHAINNAME." -p ".$this->rules_accept[$i]->proto." --dport ".$this->rules_accept[$i]->port." -i ".$this->rules_accept[$i]->device." -j ACCEPT\n";
				fwrite($handle, $string);
			}
		}
		if ($this->forward_count != -1) {
			fwrite($handle, "\n#forwards\n");
			for ($i = 0; $i <= $this->forward_count; $i++) {
				$string = IPTABLES." -t nat -A PREROUTING -p ".$this->rules_forward[$i]->proto." -i ".$this->rules_forward[$i]->device." --dport ".$this->rules_forward[$i]->port." -j DNAT --to ".$this->rules_forward[$i]->to."\n";
				fwrite($handle, $string);
			}
		}
		if ($this->block_count != -1) {
			fwrite($handle, "\n#blocks\n");
			for ($i = 0; $i <= $this->block_count; $i++) {
				$string = IPTABLES." -A ".CHAINNAME." -p ".$this->rules_block[$i]->proto." --dport ".$this->rules_block[$i]->port." -i ".$this->rules_block[$i]->device." -j REJECT\n";
				fwrite($handle, $string);
			}
		}
		if ($this->drop_count != -1) {
			fwrite($handle, "\n#drops\n");
			for ($i = 0; $i <= $this->drop_count; $i++) {
				$string = IPTABLES." -A ".CHAINNAME." -p ".$this->rules_drop[$i]->proto." --dport ".$this->rules_drop[$i]->port." -i ".$this->rules_drop[$i]->device." -j DROP\n";
				fwrite($handle, $string);
			}
		}
		fwrite($handle, "\n#drop the rest\n");
		fwrite($handle, IPTABLES." -A ".CHAINNAME." -j DROP #IGNORE\n");
		if ($this->security) {
			fwrite($handle, "\n#add security\n");
			fwrite($handle, IPTABLES." -A ".CHAINNAME." -m state --state INVALID -j DROP #IGNORE\n");
			fwrite($handle, IPTABLES." -A ".CHAINNAME." -p tcp --syn -j DROP #IGNORE\n");
			fwrite($handle, IPTABLES." -A ".CHAINNAME." -p tcp --tcp-flags ALL ALL -j DROP #IGNORE\n");
			fwrite($handle, IPTABLES." -A ".CHAINNAME." -p tcp --tcp-flags ALL NONE -j DROP #IGNORE\n");
		}
		fwrite($handle, "\n#activate rules\n");
		fwrite($handle, IPTABLES." -A FORWARD -j ".CHAINNAME." #IGNORE\n");
		fwrite($handle, IPTABLES." -A INPUT -j ".CHAINNAME." #IGNORE\n");
		fwrite($handle, IPTABLES." -A OUTPUT -j ".CHAINNAME." #IGNORE\n");
		if ($this->masq_count != -1) {
			fwrite($handle, _ECHO." 1 > /proc/sys/net/ipv4/ip_forward #IGNORE\n");
			fwrite($handle, _ECHO." 1 > /proc/sys/net/ipv4/tcp_syncookies #IGNORE\n");
		}
		fclose($handle);
	}
}

?>
